<?php
    namespace Folha\Logic\Cadastros\SetupOrganizacao;

    use \Geral\Entities\Empresa;
    use \HCM\Util\DateUtil;
    use \Geral\Util\Novocodigo;

    class CadastroEmpresa{

        const TABELA = 'EMPRESA';
        private $Cdempresa;
        private $Cdpais;
        private $Sgestado;
        private $Cdmunicipio;
        private $Nmempresa;
        private $Nmrazsocempr;
        private $Nrinsjurempr;
        private $Nrorg;
        private $Dtinclusao;
        private $Idnatuoperempr;
        private $Idregesptribemp;

        /************************** GETTERS AND SETTERS **********************/

        public function setCdempresa()
        {

            $this->Cdempresa = Novocodigo::geraCodigo($this->Nrorg, self::TABELA,1, 2, false );
        }

        public function setCdmunicipio($Cdmunicipio)
        {
            $this->Cdmunicipio = $Cdmunicipio;
        }

        public function setCdpais($Cdpais)
        {
            $this->Cdpais = $Cdpais;
        }

        public function setDtinclusao()
        {
            $this->Dtinclusao = DateUtil::getDataAtual()->format(DateUtil::FORMATO_BRASILEIRO);
        }

        public function setIdnatuoperempr($Idnatuoperempr)
        {
            $this->Idnatuoperempr = $Idnatuoperempr;
        }

        public function setIdregesptribemp($Idregesptribemp)
        {
            $this->Idregesptribemp = $Idregesptribemp;
        }

        public function setNmempresa($Nmempresa)
        {
            $this->Nmempresa = $Nmempresa;
        }

        public function setNmrazsocempr($Nmrazsocempr)
        {
            $this->Nmrazsocempr = $Nmrazsocempr;
        }

        public function setNrinsjurempr($Nrinsjurempr)
        {
            $this->Nrinsjurempr = $Nrinsjurempr;
        }

        public function setNrorg($Nrorg)
        {
            $this->Nrorg = $Nrorg;
        }

        public function setSgestado($Sgestado)
        {
            $this->Sgestado = $Sgestado;
        }

        /********************************* CONSTRUTORES **********************************/

        public function __construct($Nrorg, $Cdpais, $Sgestado,$Cdmunicipio,$Nmempresa,$Nmrazsocempr,$Nrinsjurempr){
            $this->setNrorg($Nrorg);
            $this->setDtinclusao();
            $this->setCdempresa();
            $this->setCdmunicipio($Cdmunicipio);
            $this->setCdpais($Cdpais);
            $this->setIdnatuoperempr('99');
            $this->setIdregesptribemp('99');
            $this->setNmempresa($Nmempresa);
            $this->setSgestado($Sgestado);
            $this->setNmrazsocempr($Nmrazsocempr);
            $this->setNrinsjurempr($Nrinsjurempr);

        }

        /************************************* INSERÇÃO NO BANCO DE DADOS ************************************/

        /**
         * Insere no banco de dados e retorna o CDEMPRESA
         * @return String
         */

        public function add(){

            try {

                /** @var $empresa \EmpresaEntity */

                $empresa = new \EmpresaEntity();

                $empresa->setNrorg($this->Nrorg);
                $empresa->setCdempresa($this->Cdempresa);
                $empresa->setCdmunicipio($this->Cdmunicipio);
                $empresa->setCdpais($this->Cdpais);
                $empresa->setSgestado($this->Sgestado);
                $empresa->setDtinclusao($this->Dtinclusao);
                $empresa->setIdnatuoperempr($this->Idnatuoperempr);
                $empresa->setIdregesptribemp($this->Idregesptribemp);
                $empresa->setNmempresa($this->Nmempresa);
                $empresa->setNmrazsocempr($this->Nmrazsocempr);
                $empresa->setNrinsjurempr($this->Nrinsjurempr);

                \Empresa::insereEmpresa($empresa);

                return $this->Cdempresa;
            } catch (\Exception $e) {
                tk_message($e->getMessage(),'error',false);
            }
        }
    }