<?php
use \Setforms2\Runtime\Connection;
use \Setforms2\Runtime\Strategy\Strategy;
/**
 * Estrategia para geracao de PKs.
 *
 * @package Strategy
 * @author  alessandrobartels 08/08/2011
 *
 */
class GeraIdStrategy extends Strategy{


    /**
     * Executa estrategia.
     *
     * @param TkModel &$table Instancia de TkModel.
     *
     * @see TkStrategyAbstract::execute()
     *
     * @return integer
     *
     * @author tuliobraga/alessandrobartels 08/08/2011
     *         alessandrobartels 18/05/2012 - Modificado devido a nova implementacao do Strategy.
     */
    public function execute()
    {
        $tableName = $this->getTableName();
        $pk = $this->getPkColumns();
        $columnName = $this->getColumnName();
        $step = $this->getStep();
        $params =$this->getParams();
        $param = $this->getParam(1); /* A primeira posicao do array de parametros eh a '1'. */
        $colunas = $this->getColumns();
        $data = $this->getData();


        // Quando o valor da coluna for diferente de 0 ou nulo, nao gera novo valor.
        /* alessandrobartels - 26/09/12 - A condicao abaixo foi implementada para o processo de migracao
            onde nao eh necessario gerar o strategy, mas sim passar o valor fixo. Neste caso eh preciso
            criar um DAO 'com' e um 'sem' strategy, sendo que cada um ficará no seu projeto especifico.
        */
        //if ($data[$columnName] === 0 || empty($data[$columnName]) === true) {
        return GeraId::get($columnName, $tableName, $step, $pk, $param);
        /*} else {
            return $data[$columnName];
        }*/

    }


}

class GeraId {

    public static function get($columnName, $tableName, $step, $pk, $param = null)
    {
        $db = Connection::getInstance()->getConn();
        /* Verificar o uso do SELECT MAX ... */
        if (count($pk) > 1) {
            /*@todo Parametrizar */
            /* $params = 'NRORG = '.ParametrosFacade::getNrOrgTrabalho(); */
//            $query = $db->createQuery()->select('MAX('.$columnName.')')->from($tableName)->where($param);
            $query = 'SELECT MAX('.$columnName.') FROM '.$tableName;
            if($param) $query .= ' WHERE '.$param;
        } else {
//            $query = $db->createQuery()->select('MAX('.$columnName.')')->from($tableName);
            $query = 'SELECT MAX('.$columnName.') FROM '.$tableName;
        }

        $max = (int) $db->execute($query)->fetchColumn(0);

        return $max+$step;
    }
}