/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MTBX                                                     */
/* Tabela : MOTIVOBAIXA                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 17/12/2003 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MTBX
BEFORE INSERT OR UPDATE OR DELETE
ON MOTIVOBAIXA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMTBX := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDMOTIBAIXA,0) <> NVL(:NEW.CDMOTIBAIXA,0)) OR
         (NVL(:OLD.DSMOTIBAIXA,0) <> NVL(:NEW.DSMOTIBAIXA,0)) THEN
         :NEW.DTULTATUMTBX := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MOTIVOBAIXA', '', 'CDMOTIBAIXA='||:OLD.CDMOTIBAIXA||';', SYSDATE);
   END IF;

END;
/

ALTER TABLE MOTIVOBAIXA MODIFY DTULTATUMTBX DEFAULT SYSDATE
/
