/* TECNISA - TECNOLOGIA EM INFORMTICA

NOME: 4000_DFSSTP_DELETA_NF.SQL

DESCRIO:

CRIAO:
__/__/__ - ______________________________

MANUTENES:
26/11/99 - PAULO GIOVANNI - CONVERSO P/ SQL-SERVER
*/

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'DELETA_NF' AND
	           TYPE = 'P' 			  AND
              U.UID = O.UID        AND
              U.NAME = USER)

DROP PROCEDURE DELETA_NF
GO

CREATE PROCEDURE DELETA_NF
   @P_FILIAL       VARCHAR(04),
   @P_LANCTONF     VARCHAR(10),
   @P_IDCORPITEM   VARCHAR(01) = NULL

AS
   DECLARE @V_COUNT                  NUMERIC;
   DECLARE @V_AUTOFORN               VARCHAR(10);
   DECLARE @V_CDFILIAL               VARCHAR(04);
   DECLARE @V_NRLANCTONF             VARCHAR(10);
   DECLARE @V_IDSISTEMA              VARCHAR(03);
   DECLARE @V_FILIAFATU              VARCHAR(04);
   DECLARE @V_NRAPURACFAT            VARCHAR(10);
   DECLARE @V_CDTIPOOPER             VARCHAR(02);
   DECLARE @V_VRNOTAFISC             DOUBLE PRECISION;

   DECLARE @V_ENCARGO_IDENCARGO      VARCHAR(01);
   DECLARE @V_ENCARGO_VRITEMENCA     DOUBLE PRECISION;
   DECLARE @V_IDENTRSAIDOP           VARCHAR(01);
   DECLARE @V_ETIQPED_CDFILLANC      VARCHAR(04);
   DECLARE @V_ETIQPED_CDFILDEST      VARCHAR(04);
   DECLARE @V_ETIQPED_NRPEDEXOL      VARCHAR(10);

   DECLARE @V_NRCTRLMOVEST           VARCHAR(10);
   DECLARE @V_CDFILIALENTR           VARCHAR(04);
   DECLARE @V_NRLANESTENTR           VARCHAR(10);

   DECLARE @C_LANCTOESTOQ_NRLANCESTQ VARCHAR(10);

BEGIN
   SET @V_AUTOFORN     = NULL;
   SET @V_CDTIPOOPER   = NULL;
   SET @V_COUNT        = 0;
   SET @V_FILIAFATU    = NULL;
   SET @V_NRAPURACFAT  = NULL;
   SET @V_CDFILIAL     = NULL;
   SET @V_NRLANCTONF   = NULL;
   SET @V_IDSISTEMA    = NULL;

   DELETE FROM ETIQUETAPRODOL
    WHERE (CDFILIAL   = @P_FILIAL)
      AND (NRLANCTONF = @P_LANCTONF);

   SELECT @V_IDENTRSAIDOP = MAX(IDENTRSAIDOP)
     FROM NOTAFISCAL
    WHERE (CDFILIAL   = @P_FILIAL)
      AND (NRLANCTONF = @P_LANCTONF);

   IF @V_IDENTRSAIDOP = 'S' BEGIN
      UPDATE ETIQUETAPRODOL
         SET IDSTATUSETIQ = 'A',
             DSNOTAFISORIGET = NULL
       WHERE DSNOTAFISORIGET = @P_FILIAL + @P_LANCTONF;

      DECLARE C_ETIQPED CURSOR FOR
         SELECT E.CDFILLANC, E.CDFILDEST, E.NRPEDEXOL
           FROM NOTAFISCAL NF INNER JOIN NFRELACPEXOL XOL ON NF.CDFILIAL   = XOL.CDFILIAL
                                                         AND NF.NRLANCTONF = XOL.NRLANCTONF
                              INNER JOIN ETIQUETAPRODOL E ON XOL.CDFILLANC = E.CDFILLANC
                                                         AND XOL.CDFILDEST = E.CDFILDEST
                                                         AND XOL.NRPEDEXOL = E.NRPEDEXOL                                                                        
                              INNER JOIN PARAMFILIAL P ON P.CDFILIAL = NF.CDFILIEMIT
          WHERE NF.CDFILIAL   = @P_FILIAL
            AND NF.NRLANCTONF = @P_LANCTONF
            AND P.IDETIQPRODOL= 'S'
          GROUP BY E.CDFILLANC, E.CDFILDEST, E.NRPEDEXOL;

      OPEN C_ETIQPED;

      FETCH NEXT FROM C_ETIQPED INTO @V_ETIQPED_CDFILLANC, @V_ETIQPED_CDFILDEST, @V_ETIQPED_NRPEDEXOL;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         UPDATE ETIQUETAPRODOL
            SET IDSTATUSETIQ = 'R'
          WHERE CDFILDEST = @V_ETIQPED_CDFILDEST
            AND CDFILLANC = @V_ETIQPED_CDFILLANC
            AND NRPEDEXOL = @V_ETIQPED_NRPEDEXOL
            AND IDSTATUSETIQ = 'I';

         FETCH NEXT FROM C_ETIQPED INTO @V_ETIQPED_CDFILLANC, @V_ETIQPED_CDFILDEST, @V_ETIQPED_NRPEDEXOL;
      END;

      CLOSE C_ETIQPED;
      DEALLOCATE C_ETIQPED;
   END;                                       

   SELECT @V_AUTOFORN = MAX(NRAUTOFORN)
   FROM ITEMAUTF
   WHERE (CDFILLANC  = @P_FILIAL) AND
         (NRLANCTONF = @P_LANCTONF);

   IF (@P_IDCORPITEM = 'I') OR (@P_IDCORPITEM IS NULL) BEGIN
      UPDATE ITEMVENDA
      SET CDFILIALNF  = NULL,
          NRLANCTONF  = NULL,
          NRSEQITPROD = NULL
      WHERE CDFILIALNF = @P_FILIAL AND
            NRLANCTONF = @P_LANCTONF;

      SELECT @V_CDTIPOOPER = MAX(CDTIPOOPER)
      FROM NOTAFISCAL
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      IF @V_CDTIPOOPER = '03' BEGIN
         SET @V_VRNOTAFISC = 0;
         DECLARE C_ENCARGO CURSOR FOR
            SELECT EN.IDENCARGO, SUM(VRITEMENCA) AS VRITEMENCA
            FROM ITEMENCARGO IE, ENCARGO EN
            WHERE (IE.CDFILIAL   = @P_FILIAL)    AND
                  (IE.NRLANCTONF = @P_LANCTONF)  AND
                  (IE.VRITEMENCA > 0)            AND
                  (EN.CDCTBLENTREN IS NULL)      AND
                  (EN.CDENCARGO  = IE.CDENCARGO)
            GROUP BY IDENCARGO;
         OPEN C_ENCARGO;
         FETCH NEXT FROM C_ENCARGO INTO @V_ENCARGO_IDENCARGO, @V_ENCARGO_VRITEMENCA;
         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF @V_ENCARGO_IDENCARGO = 'A' BEGIN
               SET @V_VRNOTAFISC = @V_VRNOTAFISC - @V_ENCARGO_VRITEMENCA;
            END
            ELSE IF @V_ENCARGO_IDENCARGO = 'D' BEGIN
               SET @V_VRNOTAFISC = @V_VRNOTAFISC + @V_ENCARGO_VRITEMENCA;
            END;

            OPEN C_ENCARGO;
            FETCH NEXT FROM C_ENCARGO INTO @V_ENCARGO_IDENCARGO, @V_ENCARGO_VRITEMENCA;
         END;
         CLOSE C_ENCARGO;
         DEALLOCATE C_ENCARGO;

         EXEC ATUALIZA_CUSTO_COMPLEMENTO @P_FILIAL, @P_LANCTONF, @V_VRNOTAFISC;
      END;

      DELETE FROM ITEMPROIMPOS
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM ITEMPROIMPOSORIG
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM ITEMENCARGO
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM IMPOSTONF
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM IMPOSNFTOT
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM DADOSADIC
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM IMPOSINFUSU
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM ADICDECIMPNFE
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM DECIMPNFE
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM NFPRODRURAL
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      EXEC ATUALIZA_QTRELAC_ITNFORIGEM @P_FILIAL, @P_LANCTONF, '0001', 0, 'E', 'S';

      DELETE FROM INFICMSST
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM CTRLSENHADEVOL
       WHERE (CDFILIAL   = @P_FILIAL)
         AND (NRLANCTONF = @P_LANCTONF);      

      DELETE FROM ITEMPRODUTO
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM ITEMNOTAFISC
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM HISTNEGOCIACAO
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM CONTARECEBER
      WHERE (CDFILIAL   = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      DELETE FROM NFRELACPEXOL
      WHERE (CDFILIAL   = @P_FILIAL)    AND
            (NRLANCTONF = @P_LANCTONF);

      UPDATE LANCDESPFATU
      SET    CDFILILANC =  NULL,
             NRLANCTONF =  NULL
      WHERE (CDFILILANC = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      UPDATE PREVRETI
      SET    CDFILIALNF =  NULL,
             NRLANCTONF =  NULL
      WHERE (CDFILIALNF = @P_FILIAL) AND
            (NRLANCTONF = @P_LANCTONF);

      UPDATE NOTADESTINADA
      SET CDFILIAL = NULL,
          NRLANCTONF = NULL
      WHERE (CDFILIAL = @P_FILIAL)
        AND (NRLANCTONF = @P_LANCTONF);
   END;

   SELECT @V_COUNT = COUNT(*)
   FROM LANCTOESTOQ
   WHERE CDFILIAL   = @P_FILIAL AND
         NRLANCTONF = @P_LANCTONF;

   IF @V_COUNT > 0 BEGIN

      DECLARE C_LANCTOESTOQ CURSOR FOR SELECT NRLANCESTQ
                                         FROM LANCTOESTOQ
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF;
      OPEN C_LANCTOESTOQ;

      FETCH NEXT FROM C_LANCTOESTOQ INTO @C_LANCTOESTOQ_NRLANCESTQ;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_NRCTRLMOVEST = NRCTRLMOVEST, 
                @V_CDFILIALENTR = CDFILIALENTR, 
                @V_NRLANESTENTR = NRLANESTENTR
           FROM CTRLMOVIESTQ
          WHERE CDFILIALSAID = @P_FILIAL 
            AND NRLANESTSAID = @C_LANCTOESTOQ_NRLANCESTQ;

         IF (@P_IDCORPITEM = 'I') OR (@P_IDCORPITEM IS NULL) BEGIN

            IF @V_NRCTRLMOVEST IS NOT NULL BEGIN
               DELETE 
                 FROM ITLANCTOEST
                WHERE CDFILIAL   = @V_CDFILIALENTR 
                  AND NRLANCESTQ = @V_NRLANESTENTR;
            END;

            DELETE 
              FROM ITLANCTOEST
             WHERE CDFILIAL   = @P_FILIAL 
               AND NRLANCESTQ = @C_LANCTOESTOQ_NRLANCESTQ;

            DELETE 
              FROM CUSTOCMPPROD
             WHERE CDFILLANCEST = @P_FILIAL 
               AND NRLANCESTQ   = @C_LANCTOESTOQ_NRLANCESTQ;
         END;

         IF (@P_IDCORPITEM = 'C') OR (@P_IDCORPITEM IS NULL) BEGIN

            IF @V_NRCTRLMOVEST IS NOT NULL BEGIN
               DELETE
                 FROM CTRLMOVIESTQ
                WHERE CDFILIAL     = @P_FILIAL 
                  AND NRCTRLMOVEST = @V_NRCTRLMOVEST;

               DELETE 
                 FROM LANCTOESTOQ
                WHERE CDFILIAL   = @V_CDFILIALENTR 
                  AND NRLANCESTQ = @V_NRLANESTENTR;
            END;

            DELETE 
              FROM LANCTOESTOQ
             WHERE CDFILIAL   = @P_FILIAL 
               AND NRLANCTONF = @P_LANCTONF;
         END;

         FETCH NEXT FROM C_LANCTOESTOQ INTO @C_LANCTOESTOQ_NRLANCESTQ;
      END;

      CLOSE C_LANCTOESTOQ;
      DEALLOCATE C_LANCTOESTOQ;
   END;

   SELECT @V_FILIAFATU   = CDFILIAL,
          @V_NRAPURACFAT = NRAPURACFAT
   FROM NOTAFISCAL
   WHERE (CDFILIAL   = @P_FILIAL) AND
         (NRLANCTONF = @P_LANCTONF);

   UPDATE EFECLIFAT
   SET CDFILIFATU  = NULL,
       NRAPURACFAT = NULL
   WHERE (CDFILIFATU  = @V_FILIAFATU)    AND
         (NRAPURACFAT = @V_NRAPURACFAT);

   UPDATE  EFETCLIE
   SET CDFILIFATU  = NULL,
       NRAPURACFAT = NULL
   WHERE (CDFILIFATU  = @V_FILIAFATU)    AND
         (NRAPURACFAT = @V_NRAPURACFAT);

   IF (@P_IDCORPITEM = 'C') OR (@P_IDCORPITEM IS NULL) BEGIN
      IF @V_AUTOFORN IS NULL BEGIN
         DELETE FROM CONTAPAGAR
         WHERE (CDFILIAL   = @P_FILIAL) AND
               (NRLANCTONF = @P_LANCTONF);

         DELETE FROM NFRELACAF
         WHERE (CDFILIAL   = @P_FILIAL) AND
               (NRLANCTONF = @P_LANCTONF);

         DELETE FROM ARQXMLNFE
         WHERE (CDFILIAL     = @P_FILIAL) AND
               (NRLANCTONF   = @P_LANCTONF);

         DELETE FROM NOTAFISCAL
         WHERE (CDFILIAL     = @P_FILIAL) AND
               (NRLANCTONF   = @P_LANCTONF);
      END
      ELSE BEGIN
         SELECT @V_CDFILIAL = MAX(N.CDFILIAL), @V_NRLANCTONF = MAX(N.NRLANCTONF),
                @V_IDSISTEMA = MAX(IDSISTEMA)
         FROM ITEMAUTF I, NOTAFISCAL N
         WHERE I.CDFILLANC  = @P_FILIAL      AND
               I.NRLANCTONF = @P_LANCTONF    AND
               I.CDFILLANC  = N.CDFILIAL     AND
               I.NRLANCTONF = N.NRLANCTONF;

         IF ISNULL(@V_IDSISTEMA,'DFE') = 'DFE' BEGIN
            UPDATE ITEMAUTF
            SET CDFILLANC  = @P_FILIAL,
                NRLANCTONF = @P_LANCTONF
            WHERE CDFILLANC  = @V_CDFILIAL AND
                  NRLANCTONF = @V_NRLANCTONF;

            DELETE FROM NFRELACAF
            WHERE (CDFILIAL   = @P_FILIAL) AND
                  (NRLANCTONF = @P_LANCTONF);

            UPDATE NOTAFISCAL
            SET IDERROS      = NULL,
                IDAVISOS     = NULL,
                DTEMISSAO    = NULL,
                IDSISTEMA    = 'CMP',
                CDSERIEENTR  = NULL,
                NRNOTAFISC   = NULL,
                IDSTATUS     = 'V',
                CDFISOPENTF  = NULL,
                DSCDFISOPENF = NULL
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF;
         END
         ELSE BEGIN
            DELETE FROM CONTAPAGAR
            WHERE (CDFILIAL   = @P_FILIAL) AND
                  (NRLANCTONF = @P_LANCTONF);

            DELETE FROM NFRELACAF
            WHERE (CDFILIAL   = @P_FILIAL) AND
                  (NRLANCTONF = @P_LANCTONF);

            DELETE FROM ARQXMLNFE
            WHERE (CDFILIAL     = @P_FILIAL) AND
                  (NRLANCTONF   = @P_LANCTONF);

            DELETE FROM ERRONFPREVALID
            WHERE (CDFILIAL = @P_FILIAL)
              AND (NRLANCTONF = @P_LANCTONF);

            DELETE FROM NFPREVALIDFIS
            WHERE (CDFILIAL = @P_FILIAL)
              AND (NRLANCTONF = @P_LANCTONF);

            DELETE FROM NOTABCMENSAL
            WHERE (CDFILIAL     = @P_FILIAL) AND
                  (NRLANCTONF   = @P_LANCTONF);
                  
            DELETE FROM NOTAFISCAL
            WHERE (CDFILIAL     = @P_FILIAL) AND
                  (NRLANCTONF   = @P_LANCTONF);
         END;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DELETA_NF','6.00.xxx';
GO
