const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po');
const tipoDeCreditoBancario = require('../../../page-objects/parametrizacao/financeiro/tipoDeCreditoBancario.po');
describe('Tipo de Crédito Bancário', () => {
    beforeEach(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        tipoDeCreditoBancario.abrir();
    });

    afterEach(() => {
        geral.sair();
    });
    it('Acessar tela de Tipo de Crédito Bancário', () => {
        expect(z.component.header.getTitle()).toBe('Tipo de Crédito Bancário');
    });
    it('Realizar o preenchimento dos campos solicitados na página', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-76688774634495175574165')));
        geral.clickAdicionar();
        tipoDeCreditoBancario.adicionar(j.getValor('codigoTipoDeCredito'), j.getValor('descricaoCreditoBancario'),
            j.getValor('historicoIntegracao'), j.getValor('contacontabil'), j.getValor('classificacaoFinanceira'),
            j.getValor('contabilizaLancamento'));
        geral.clickSalvar();
        geral.filterIt(j.getValor('descricaoCreditoBancario'));
        expect(geral.gridHasText('76688774634495175574165', j.getValor('descricaoCreditoBancario'), 1)).toBe(j.getValor('descricaoCreditoBancario'));
    });
    it('Editar Registro', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-76688774634495175574165')));
        geral.filterIt(j.getValor('descricaoCreditoBancario'));
        geral.clickGrid('DSTPCREDBANC', j.getValor('descricaoCreditoBancario'), '76688774634495175574165');
        geral.clickEditar();
        tipoDeCreditoBancario.editar(j.getValor('descricaoCreditoBancario1'), j.getValor('historicoIntegracao1'),
        j.getValor('contacontabil1'), j.getValor('classificacaoFinanceira1'), j.getValor('contabilizaLancamento1'));
        geral.clickSalvar();
        geral.clickVoltar();
        geral.filterIt(j.getValor('descricaoCreditoBancario1'));
        expect(geral.gridHasText('76688774634495175574165', j.getValor('descricaoCreditoBancario1'), 1)).toBe(j.getValor('descricaoCreditoBancario1'));
    });
    it('Excluir Registro', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-76688774634495175574165')));
        geral.filterIt(j.getValor('descricaoCreditoBancario1'));
        geral.clickGrid('DSTPCREDBANC', j.getValor('descricaoCreditoBancario1'), '76688774634495175574165');
        geral.clickExcluir();
        geral.clickSim();
        geral.filterIt(j.getValor('descricaoCreditoBancario1'));
        expect(geral.gridHasText('76688774634495175574165', j.getValor('descricaoCreditoBancario1'), 1)).toBeUndefined();
    }
    );
});
